## limesuite 16.8.23.819%2bgit20161221%2bdfsg

=== CMakeLists.txt ===
########################################################################
## Create lime-suite project
########################################################################
cmake_minimum_required(VERSION 3.1.3)
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo" CACHE TYPE INTERNAL FORCE)
project("LimeSuite")

option(BUILD_SHARED_LIBS "Build the shared library" ON)

#include modules for finding CyAPI
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/Modules/")

cmake_policy(SET CMP0015 OLD)
if(${CMAKE_MAJOR_VERSION} GREATER 2)
    cmake_policy(SET CMP0043 NEW)
endif()

if (CMAKE_BUILD_TYPE STREQUAL "")
   set(CMAKE_BUILD_TYPE "Release")
endif()

########################################################################
# gather version information
########################################################################

# extract library version number from generated version.h
# in the future, this might be recoreded directly here
# use the date stamp and build number to make a dotted version
file(READ "${PROJECT_SOURCE_DIR}/src/version.h" version_h)
string(REGEX MATCH "static const int year = 20([0-9]+)" VERSION_MATCHES "${version_h}")
set(VERSION_MAJOR ${CMAKE_MATCH_1})
string(REGEX MATCH "static const int month = ([0-9]+)" VERSION_MATCHES "${version_h}")
set(VERSION_MINOR ${CMAKE_MATCH_1})
string(REGEX MATCH "static const int day = ([0-9]+)" VERSION_MATCHES "${version_h}")
set(VERSION_PATCH ${CMAKE_MATCH_1})
string(REGEX MATCH "static const int buildsCounter = ([0-9]+)" VERSION_MATCHES "${version_h}")
set(BUILD_NUMBER ${CMAKE_MATCH_1})
set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${BUILD_NUMBER}")

# the ABI compatibility number should be incremented when the ABI changes
# the format is to use the same major and minor, but to have an incrementing
# number if there are changes within the major.minor release series
set(LIME_SUITE_SOVER "${VERSION_MAJOR}.${VERSION_MINOR}-1")

# packagers may specify -DLIME_SUITE_EXTVER="foo" to replace the git hash
if (NOT LIME_SUITE_EXTVER)
    include(${PROJECT_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake)
    get_git_head_revision(GITREFSPEC GITHASH)
    if (GITHASH)
        string(SUBSTRING "${GITHASH}" 0 8 GITHASH)
        set(LIME_SUITE_EXTVER "g${GITHASH}")
    else (GITHASH)
        set(LIME_SUITE_EXTVER "unknown")
    endif (GITHASH)
endif()

set(LIME_SUITE_VERSION "${LIME_SUITE_LIBVER}-${LIME_SUITE_EXTVER}")
string(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d")

########################################################################
## compiler flags
########################################################################

#C++11 is a required language feature for this project
set(CMAKE_CXX_STANDARD 11)

if(CMAKE_COMPILER_IS_GNUCXX)

    #enable C++11 on older versions of cmake
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
    endif()

    #common warnings enabled
    add_compile_options(-Wall)

    #symbols are only exported from libraries/modules explicitly
    add_compile_options(-fvisibility=hidden)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fvisibility-inlines-hidden")
endif()

if (MSVC)
    include_directories(${PROJECT_SOURCE_DIR}/external/msvc)
    add_definitions(-D_CRT_SECURE_NO_WARNINGS)
    set( MSVC_MULTITHREAD_COMPILE_FLAGS "/MP")
    set( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} ${MSVC_MULTITHREAD_COMPILE_FLAGS}" )
endif(MSVC)

if (APPLE)
   add_definitions(-D__unix__=1) #we use this for unix detection, but clang does not define it
endif(APPLE)

########################################################################
# rpath setup - http://www.cmake.org/Wiki/CMake_RPATH_handling
########################################################################
# use, i.e. don't skip the full RPATH for the build tree
option(CMAKE_SKIP_BUILD_RPATH "skip rpath build" FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
option(CMAKE_BUILD_WITH_INSTALL_RPATH "build with install rpath" FALSE)

# the RPATH to be used when installing, but only if it's not a system directory
option(CMAKE_AUTOSET_INSTALL_RPATH TRUE)
if(CMAKE_AUTOSET_INSTALL_RPATH)
LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" isSystemDir)
IF("${isSystemDir}" STREQUAL "-1")
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
ENDIF("${isSystemDir}" STREQUAL "-1")
endif(CMAKE_AUTOSET_INSTALL_RPATH)

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
option(CMAKE_INSTALL_RPATH_USE_LINK_PATH "build with automatic rpath" TRUE)

if(APPLE)
    set(CMAKE_MACOSX_RPATH ON)
endif()

########################################################################
## sqlite dependency
########################################################################
if(WIN32)
    add_subdirectory(external/sqlite-3.12)
    set(SQLITE3_FOUND TRUE)
    set(SQLITE3_INCLUDE_DIRS)
    set(SQLITE3_LIBRARIES sqlite3_static)
else()
    find_package(SQLite3)
    if (NOT SQLITE3_FOUND)
        message(SEND_ERROR "Failed to find sqlite3 devel, please install libsqlite3-dev")
    endif()

    message(STATUS "SQLITE3: ${SQLITE3_FOUND}")
    message(STATUS "SQLITE3_INCLUDE_DIRS: ${SQLITE3_INCLUDE_DIRS}")
    message(STATUS "SQLITE3_LIBRARIES: ${SQLITE3_LIBRARIES}")
endif()

########################################################################
## lime suite build
########################################################################
add_subdirectory(src)

########################################################################
## SoapySDR bindings for LMS7 RFIC driver
########################################################################
add_subdirectory(SoapyLMS7)

########################################################################
## udev rules for linux usb
########################################################################
if (DEFINED UDEV_RULES_PATH)
    install(
        FILES ${CMAKE_CURRENT_SOURCE_DIR}/udev-rules/64-limesuite.rules
        DESTINATION ${UDEV_RULES_PATH})
endif()

########################################################################
## freedesktop environment integration
########################################################################
add_subdirectory(Desktop)

#########################################################################
# summary
#########################################################################
include(FeatureSummary)
message(STATUS "")
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} enabled features")
message(STATUS "######################################################")
feature_summary(WHAT ENABLED_FEATURES)
message(STATUS "######################################################")
message(STATUS "## ${PROJECT_NAME} disabled features")
message(STATUS "######################################################")
feature_summary(WHAT DISABLED_FEATURES)
message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")
message(STATUS "Build timestamp: ${BUILD_TIMESTAMP}")
message(STATUS "Lime Suite version: ${LIME_SUITE_VERSION}")
message(STATUS "ABI/so version: ${LIME_SUITE_SOVER}")

########################################################################
# uninstall target
########################################################################
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY)

#only add uninstall target if this is the top project
if(${CMAKE_PROJECT_NAME} STREQUAL ${PROJECT_NAME})
add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)
endif()

=== mcu_program/CMakeLists.txt ===
#project directory inside LimeSuite/mcu_program
cmake_policy(SET CMP0003 NEW)
#C++11 is a required language feature for this project
set(CMAKE_CXX_STANDARD 11)

#include modules for finding CyAPI
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}")
if(WIN32)
    find_package(CyAPI)
    include_directories( ${CYAPI_INCLUDE_DIRS})
    set(USB_LIBRARIES ${CYAPI_LIBRARIES} SetupAPI)
endif()

if(CMAKE_COMPILER_IS_GNUCXX)

    #enable C++11 on older versions of cmake
    if (CMAKE_VERSION VERSION_LESS "3.1")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11x")
    endif()

    #common warnings enabled
    add_compile_options(-Wall)
endif()

set(HOST_SOURCES
    host_src/mcu.c 
    host_src/main.cpp
    host_src/spi.cpp
    host_src/mcuHexBin.cpp
    common_src/lms7002m_calibrations.c
    common_src/lms7002m_controls.c
    common_src/LMS7002M_parameters_compact.c
)

SET_SOURCE_FILES_PROPERTIES( 
	host_src/mcu.c
	common_src/lms7002m_calibrations.c
	common_src/lms7002m_controls.c
    common_src/LMS7002M_parameters_compact.c
	PROPERTIES LANGUAGE CXX )


include_directories(../src)
include_directories(../src/lms7002m)
include_directories(../src/ConnectionRegistry)
include_directories(../src/ConnectionSTREAM)
include_directories(../src/protocols)
include_directories(common_src)

add_executable(mcu_calibration ${HOST_SOURCES})
if(WIN32)
target_link_libraries(mcu_calibration LimeSuite sqlite3_static)
else()
target_link_libraries(mcu_calibration LimeSuite sqlite3)
endif()
if(WIN32)
    target_link_libraries(mcu_calibration ${CYAPI_LIBRARIES} SetupAPI)
endif()

=== src/CMakeLists.txt ===
########################################################################
## public headers
########################################################################
set(LIME_SUITE_PUBLIC_HEADERS
    lime/LimeSuite.h
    VersionInfo.h
    ErrorReporting.h
    LimeSuiteConfig.h
    ADF4002/ADF4002.h
    version.h
    lms7002m_mcu/MCU_BD.h
    lms7002m_mcu/MCU_File.h
    ConnectionRegistry/IConnection.h
    ConnectionRegistry/ConnectionHandle.h
    ConnectionRegistry/ConnectionRegistry.h
    lms7002m/LMS7002M.h
    lms7002m/LMS7002M_RegistersMap.h
    lms7002m/LMS7002M_parameters.h
    protocols/ADCUnits.h
    protocols/LMS64CCommands.h
    protocols/LMS64CProtocol.h
    protocols/ILimeSDRStreaming.cpp
    protocols/LMSBoards.h
    protocols/dataTypes.h
    protocols/fifo.h
    Si5351C/Si5351C.h
    FPGA_common/FPGA_common.h
    lime/LimeSuite.h
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_HEADERS "Enable install headers" ON "TRUE" OFF)
add_feature_info(LimeSuiteHeaders ENABLE_HEADERS "The lime suite headers")
if (ENABLE_HEADERS)
    install(
        FILES ${LIME_SUITE_PUBLIC_HEADERS}
        DESTINATION include/lime
    )
endif()

########################################################################
## lime suite library
########################################################################
set(LIME_SUITE_SOURCES
    ErrorReporting.cpp
    ADF4002/ADF4002.cpp
    lms7002m_mcu/MCU_BD.cpp
    ConnectionRegistry/IConnection.cpp
    ConnectionRegistry/ConnectionHandle.cpp
    ConnectionRegistry/ConnectionRegistry.cpp
    lms7002m/LMS7002M_RegistersMap.cpp
    lms7002m/LMS7002M_parameters.cpp
    lms7002m/LMS7002M.cpp
    lms7002m/LMS7002M_RxTxCalibrations.cpp
    lms7002m/goert.cpp
    lms7002m/mcu_dc_iq_calibration.cpp
    lms7002m/CalibrationCache.cpp
    lms7002m/LMS7002M_filtersCalibration.cpp
    protocols/LMS64CProtocol.cpp
    protocols/ILimeSDRStreaming.cpp
    Si5351C/Si5351C.cpp
    kissFFT/kiss_fft.c
    API/lms7_api.cpp
    API/lms7_device.cpp
    FPGA_common/FPGA_common.cpp
    windowFunction.cpp
)

set(LIME_SUITE_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}
    API
    GFIR
    protocols
    ConnectionRegistry
    lms7002m_mcu
    ADF4002
    Si5351C
    lms7002m
    LTEpackets
    FPGA_common
    lms7002m_mcu
    ${PROJECT_SOURCE_DIR}/external/cpp-feather-ini-parser
    HPM7
    kissFFT
)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/VersionInfo.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp @ONLY)
list(APPEND LIME_SUITE_SOURCES ${CMAKE_CURRENT_BINARY_DIR}/VersionInfo.cpp)

if(CMAKE_COMPILER_IS_GNUCXX)
    list(APPEND LIME_SUITE_LIBRARIES -pthread)
endif(CMAKE_COMPILER_IS_GNUCXX)

#sqlite depedency
list(APPEND LIME_SUITE_INCLUDES ${SQLITE3_INCLUDE_DIRS})
list(APPEND LIME_SUITE_LIBRARIES ${SQLITE3_LIBRARIES})

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_LIBRARY "Enable build library" ON "SQLITE3_FOUND" OFF)
add_feature_info(LimeSuiteLibrary ENABLE_LIBRARY "The lime suite library")
if (ENABLE_LIBRARY)
    add_library(LimeSuite ${LIME_SUITE_SOURCES})
    target_link_libraries(LimeSuite ${LIME_SUITE_LIBRARIES})
    set_property(TARGET LimeSuite PROPERTY POSITION_INDEPENDENT_CODE TRUE)
    set_target_properties(LimeSuite PROPERTIES SOVERSION ${LIME_SUITE_SOVER})
    set_target_properties(LimeSuite PROPERTIES VERSION ${LIME_SUITE_LIBVER})
    set_target_properties(LimeSuite PROPERTIES DEFINE_SYMBOL "LIME_DLL_EXPORTS")
    target_include_directories(LimeSuite PUBLIC ${LIME_SUITE_INCLUDES})
    if(BUILD_SHARED_LIBS)
        target_compile_definitions(LimeSuite PUBLIC "LIME_DLL")
    endif()

    install(TARGETS LimeSuite
        LIBRARY DESTINATION lib${LIB_SUFFIX} # .so file
        ARCHIVE DESTINATION lib${LIB_SUFFIX} # .lib file
        RUNTIME DESTINATION bin              # .dll file
    )

	if (MSVC)
		set_target_properties(LimeSuite PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
	endif(MSVC)

    add_subdirectory(GFIR)
    set(LIME_SUITE_LIBS LimeSuite)
endif()

########################################################################
## Supported connections
########################################################################
include(ConnectionEVB7COM/CMakeLists.txt)
include(ConnectionSTREAM/CMakeLists.txt)
include(ConnectionSTREAM_UNITE/CMakeLists.txt)
include(ConnectionNovenaRF7/CMakeLists.txt)
include(Connection_uLimeSDR/CMakeLists.txt)
include(ConnectionXillybus/CMakeLists.txt)

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionRegistry/BuiltinConnections.in.cpp
    ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp
)

target_sources(LimeSuite PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/BuiltinConnections.cpp)

########################################################################
## wx widgets dependency
########################################################################
set(wxWidgets_USE_DEBUG OFF)
set(wxWidgets_USE_UNICODE ON)
set(wxWidgets_USE_UNIVERSAL OFF)
set(wxWidgets_USE_STATIC ON)
find_package(wxWidgets COMPONENTS richtext xml html xrc adv aui core base gl)
message(STATUS "wxWidgets_DEFINITIONS: ${wxWidgets_DEFINITIONS}")
message(STATUS "wxWidgets_INCLUDE_DIRS: ${wxWidgets_INCLUDE_DIRS}")
message(STATUS "wxWidgets_LIBRARIES: ${wxWidgets_LIBRARIES}")

########################################################################
## LimeSuite GUI app
########################################################################
set(LMS7SUITE_GUI_SOURCES
    ADF4002/ADF4002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlBuffers_view.cpp
    lms7002_wxgui/lms7002_pnlXBUF_view.cpp
    lms7002_wxgui/lms7002_wxgui.cpp
    lms7002_wxgui/lms7002_pnlRFE_view.cpp
    lms7002_wxgui/lms7002_pnlCalibrations_view.cpp
    lms7002_wxgui/lms7002_pnlTRF_view.cpp
    lms7002_wxgui/lms7002_pnlCDS_view.cpp
    lms7002_wxgui/lms7002_pnlLimeLightPAD_view.cpp
    lms7002_wxgui/lms7002_pnlBIST_view.cpp
    lms7002_wxgui/dlgViewIRAM.cpp
    lms7002_wxgui/lms7002_gui_utilities.cpp
    lms7002_wxgui/lms7002_pnlSX_view.cpp
    lms7002_wxgui/lms7002_pnlTBB_view.cpp
    lms7002_wxgui/lms7002_dlgVCOfrequencies.cpp
    lms7002_wxgui/lms7002_pnlRBB_view.cpp
    lms7002_wxgui/lms7002_pnlLDO_view.cpp
    lms7002_wxgui/lms7002_pnlAFE_view.cpp
    lms7002_wxgui/CoefficientFileParser.cpp
    lms7002_wxgui/lms7002_pnlRxTSP_view.cpp
    lms7002_wxgui/lms7002_mainPanel.cpp
    lms7002_wxgui/pnlBoardControls.cpp
    lms7002_wxgui/dlgViewSFR.cpp
    lms7002_wxgui/lms7002_pnlCLKGEN_view.cpp
    lms7002_wxgui/lms7002_pnlMCU_BD_view.cpp
    lms7002_wxgui/lms7002_pnlBIAS_view.cpp
    lms7002_wxgui/lms7002_dlgGFIR_Coefficients.cpp
    lms7002_wxgui/lms7002_pnlTxTSP_view.cpp
    LMS_Programing/LMS_Programing_wxgui.cpp
    utilities_gui/dlgConnectionSettings.cpp
    utilities_gui/pnlMiniLog.cpp
    utilities_gui/SPI_wxgui.cpp
    utilities_gui/dlgFullMessageLog.cpp
    utilities_gui/dlgDeviceInfo.cpp
    utilities_gui/utilities_gui.cpp
    lms7suiteAppFrame.cpp
    boards_wxgui/lms7002m_novena_wxgui.cpp
    RFSpark/RFSpark_wxgui.cpp
    Si5351C/Si5351C_wxgui.cpp
    lms7suiteApp_gui.cpp
    lms7suiteApp.cpp
    FPGAcontrols_wxgui/FPGAcontrols_wxgui.cpp
    HPM7/HPM7_wxgui.cpp
    dlgAbout.cpp
    numericSlider/numericSlider.cpp
    myriad7/myriad7_wxgui.cpp
    fftviewer_wxgui/fftviewer_wxgui.cpp
    fftviewer_wxgui/fftviewer_frFFTviewer.cpp
    lms7suiteEvents/lms7suiteEvents.cpp
    boards_wxgui/pnlQSpark.cpp
    boards_wxgui/pnluLimeSDR.cpp
    kissFFT/kiss_fft.c
    windowFunction.cpp
    boards_wxgui/pnlLimeSDR.cpp
)

include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_GUI "Enable build GUI" ON "ENABLE_LIBRARY;wxWidgets_FOUND" OFF)
add_feature_info(LimeSuiteGUI ENABLE_GUI "GUI Application for LimeSuite")
if (ENABLE_GUI)

    include_directories(lms7002_wxgui)
    include_directories(LMS_Programing)
    include_directories(utilities_gui)
    include_directories(RFSpark)
    include_directories(FPGAcontrols_wxgui)
    include_directories(numericSlider)
    include_directories(myriad7)
    include_directories(fftviewer_wxgui)
    include_directories(lms7suiteEvents)
    include_directories(boards_wxgui)
    include(${wxWidgets_USE_FILE})
    add_subdirectory(oglGraph)

    set(BINARY_OUTPUT_DIR "${CMAKE_BINARY_DIR}/bin")

    add_executable(LimeSuiteGUI ${LMS7SUITE_GUI_SOURCES} resources/resource.rc)
    set_target_properties(LimeSuiteGUI PROPERTIES
        RUNTIME_OUTPUT_DIRECTORY ${BINARY_OUTPUT_DIR})
    target_link_libraries(LimeSuiteGUI LimeSuite oglGraph ${wxWidgets_LIBRARIES})

    if (MSVC)
        set_property(TARGET LimeSuiteGUI APPEND PROPERTY LINK_FLAGS /SUBSYSTEM:WINDOWS)
    endif(MSVC)

    install(TARGETS LimeSuiteGUI DESTINATION bin)

endif()

########################################################################
## update version.h
########################################################################
set(AUTO_UPDATE_VERSION OFF CACHE BOOL "Uses python script to increment version")
if(AUTO_UPDATE_VERSION)
	add_custom_target(updateVersion ALL COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/auto_version.py WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
	add_dependencies(lms7suite updateVersion)
endif()

########################################################################
# boardEmulator -- creates serial port and imitates board communications
########################################################################
if(UNIX)
    add_executable(boardEmulator boardEmulator.cpp)
    target_link_libraries(boardEmulator LimeSuite)
endif()

#########################################################################
# utilities
#########################################################################
cmake_dependent_option(ENABLE_UTILITIES "Enable utility programs" OFF "ENABLE_LIBRARY" OFF)
add_feature_info(LimeSuiteUtilities ENABLE_UTILITIES "Additional utility programs for testing")
if(ENABLE_UTILITIES)
    include_directories(utilityTools)
    set(utility_src_files utilityTools/pllTest.cpp)
    add_executable(utilityTools ${utility_src_files} utilityTools/main.cpp)
    target_link_libraries(utilityTools LimeSuite)
endif()

########################################################################
# Lime Util -- command line utility, info and connections
########################################################################
cmake_dependent_option(ENABLE_LIME_UTIL "LimeSuite device utility" ON "ENABLE_LIBRARY" OFF)
add_feature_info(LimeUtilCommand ENABLE_LIME_UTIL "Command line device discovery utility")
if(ENABLE_LIME_UTIL)
    add_executable(LimeUtil LimeUtil.cpp LimeUtilTiming.cpp)
    target_link_libraries(LimeUtil LimeSuite)
    install(TARGETS LimeUtil DESTINATION bin)
endif()

#########################################################################
# tests
#########################################################################
add_subdirectory(tests)

#########################################################################
# examples
#########################################################################
add_subdirectory(examples)

=== src/ConnectionNovenaRF7/CMakeLists.txt ===
########################################################################
## Support for NovenaRF7 connection
########################################################################

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionNovenaRF7)

set(CONNECTION_NOVENARF7_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7Entry.cpp
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7.cpp
    ${THIS_SOURCE_DIR}/ConnectionNovenaRF7_streaming.cpp
    ${THIS_SOURCE_DIR}/StreamChannel.cpp
)

include(CheckIncludeFile)
set(CMAKE_REQUIRED_DEFINITIONS -DNULL=0)
CHECK_INCLUDE_FILE(linux/spi/spidev.h HAS_SPIDEV_H)
CHECK_INCLUDE_FILE(linux/i2c-dev.h HAS_I2CDEV_H)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_NOVENARF7 "Enable NovenaRF7" ON "ENABLE_LIBRARY;HAS_SPIDEV_H;HAS_I2CDEV_H" OFF)
add_feature_info(ConnectionNovenaRF7 ENABLE_NOVENARF7 "NovenaRF7 Connection support")
if (NOT ENABLE_NOVENARF7)
    return()
endif()

########################################################################
## Add to library
########################################################################
target_sources(LimeSuite PRIVATE ${CONNECTION_NOVENARF7_SOURCES})

## limesuite 16.8.23.819+git20161221+dfsg

=== debian/changelog ===
limesuite (16.8.23.819+git20161221+dfsg-1) unstable; urgency=medium

  * Initial release (Closes: #847798)

 -- Andreas Bombe <aeb@debian.org>  Thu, 22 Dec 2016 02:11:19 +0100

=== debian/control ===
Source: limesuite
Section: hamradio
Priority: optional
Maintainer: Debian Hamradio Maintainers <debian-hams@lists.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper (>= 10),
               cmake,
               pkg-config,
               libusb-1.0-0-dev,
               libwxgtk3.0-dev,
               libsoapysdr-dev,
               libi2c-dev,
               freeglut3-dev,
               libglew-dev,
               libsqlite3-dev
Standards-Version: 3.9.8
Homepage: https://myriadrf.org/projects/lime-suite/
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hamradio/limesuite.git
Vcs-Git: https://anonscm.debian.org/git/pkg-hamradio/limesuite.git

Package: limesuite
Architecture: any
Depends: liblimesuite16.8-1 (>= ${binary:Version}),
         python, python-soapysdr,
         ${shlibs:Depends}, ${misc:Depends}
Description: tools to test, control and update LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the command line and GUI tools to control and update the
 hardware devices.

Package: liblimesuite16.8-1
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: limesuite-udev [linux-any]
Description: library to access LMS7 transceiver based hardware
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the shared library to access LMS7 based hardware.

Package: liblimesuite-dev
Section: libdevel
Architecture: any
Depends: liblimesuite16.8-1 (= ${binary:Version}),
         ${misc:Depends}
Description: library to access LMS7 transceiver based hardware (development)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the development files for liblimesuite.

Package: soapysdr0.5-2-module-lms7
Architecture: any
Multi-Arch: same
Depends: liblimesuite16.8-1 (>= ${binary:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains a SoapySDR module to use LMS7 based hardware to transmit
 and receive.

Package: soapysdr-module-lms7
Architecture: any
Multi-Arch: same
Depends: soapysdr0.5-2-module-lms7, ${misc:Depends}
Description: Lime Microsystems LMS7 device support for SoapySDR (default version)
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This is an ampty dependency package that pulls in the LMS7 support module for
 the default version of libsoapysdr.

Package: limesuite-udev
Section: libs
Architecture: all
Depends: ${misc:Depends}
Description: Lime Suite - USB rules for udev
 Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
 transceiver based hardware such as the LimeSDR, LMS7002M UNITE board, or the
 Novena with LMS7 RF board.
 .
 This package contains the udev rules to make LMS7 based hardware accessible to
 users in the plugdev group.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# extract the architecture for setting the library path suffix
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# extract the last section of the changelog version for extra info
DEB_VERSION ?= $(shell dpkg-parsechangelog -S Version)

# use changelog timestamp instead of build timestamp for reproducible builds
DEB_TIMESTAMP ?= $(shell date --date=@$(shell dpkg-parsechangelog -S Timestamp) +%Y-%m-%d)

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_SHARED_LIBS=ON \
		-DCMAKE_AUTOSET_INSTALL_RPATH=FALSE \
		-DUDEV_RULES_PATH=/lib/udev/rules.d \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DOVERRIDE_LIME_SUITE_VERSION="$(DEB_VERSION)" \
		-DOVERRIDE_TIMESTAMP="$(DEB_TIMESTAMP)"

override_dh_installdocs:
	dh_installdocs -p soapysdr-module-lms7 \
                --link-doc=soapysdr0.5-2-module-lms7
	dh_installdocs --remaining-packages

## limesuite 16.12.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,20 +22,13 @@
 ########################################################################
 # gather version information
 ########################################################################
-
-# extract library version number from generated version.h
-# in the future, this might be recoreded directly here
-# use the date stamp and build number to make a dotted version
-file(READ "${PROJECT_SOURCE_DIR}/src/version.h" version_h)
-string(REGEX MATCH "static const int year = 20([0-9]+)" VERSION_MATCHES "${version_h}")
-set(VERSION_MAJOR ${CMAKE_MATCH_1})
-string(REGEX MATCH "static const int month = ([0-9]+)" VERSION_MATCHES "${version_h}")
-set(VERSION_MINOR ${CMAKE_MATCH_1})
-string(REGEX MATCH "static const int day = ([0-9]+)" VERSION_MATCHES "${version_h}")
-set(VERSION_PATCH ${CMAKE_MATCH_1})
-string(REGEX MATCH "static const int buildsCounter = ([0-9]+)" VERSION_MATCHES "${version_h}")
-set(BUILD_NUMBER ${CMAKE_MATCH_1})
-set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}.${BUILD_NUMBER}")
+# The version of this library: major, minor, and patch
+# Manually increment these numbers when creating releases.
+# LIME_SUITE_API_VERSION in VersionInfo.h reflects the major/minor,
+# and must be set manually when non-patch releases are created.
+set(VERSION_MAJOR 16)
+set(VERSION_MINOR 12)
+set(VERSION_PATCH 0)
 
 # the ABI compatibility number should be incremented when the ABI changes
 # the format is to use the same major and minor, but to have an incrementing
@@ -54,6 +47,7 @@
     endif (GITHASH)
 endif()
 
+set(LIME_SUITE_LIBVER "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
 set(LIME_SUITE_VERSION "${LIME_SUITE_LIBVER}-${LIME_SUITE_EXTVER}")
 string(TIMESTAMP BUILD_TIMESTAMP "%Y-%m-%d")
 
@@ -140,6 +134,7 @@
 ## lime suite build
 ########################################################################
 add_subdirectory(src)
+add_subdirectory(mcu_program)
 
 ########################################################################
 ## SoapySDR bindings for LMS7 RFIC driver

=== SoapyLMS7/CMakeLists.txt ===
########################################################################
## SoapySDR bindings for LMS7
########################################################################

find_package(SoapySDR CONFIG)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_SOAPY_LMS7 "Enable LMS7 SoapySDR bindings" ON "ENABLE_LIBRARY;SoapySDR_FOUND" OFF)
add_feature_info(SoapySDRLMS7 ENABLE_SOAPY_LMS7 "SoapySDR bindings for LMS7")
if (NOT ENABLE_SOAPY_LMS7)
    return()
endif()

########################################################################
## Build support module
########################################################################
if(CMAKE_COMPILER_IS_GNUCXX)

    #disable warnings for unused parameters
    add_definitions(-Wno-unused-parameter)

endif(CMAKE_COMPILER_IS_GNUCXX)

SOAPY_SDR_MODULE_UTIL(
    TARGET LMS7Support
    SOURCES
        Registration.cpp
        Settings.cpp
        Streaming.cpp
    LIBRARIES
        LimeSuite
)

########################################################################
## Calibration utility
########################################################################
if(UNIX)
    set(LIME_SUITE_CAL_NAME LimeSuiteCalibrate)
elseif (WIN32)
    set(LIME_SUITE_CAL_NAME LimeSuiteCalibrate.py)
endif()

install(
    PROGRAMS LimeSuiteCalibrate.py
    RENAME ${LIME_SUITE_CAL_NAME}
    DESTINATION bin
)

=== mcu_program/CMakeLists.txt ===
--- 
+++ 
@@ -2,14 +2,6 @@
 cmake_policy(SET CMP0003 NEW)
 #C++11 is a required language feature for this project
 set(CMAKE_CXX_STANDARD 11)
-
-#include modules for finding CyAPI
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}")
-if(WIN32)
-    find_package(CyAPI)
-    include_directories( ${CYAPI_INCLUDE_DIRS})
-    set(USB_LIBRARIES ${CYAPI_LIBRARIES} SetupAPI)
-endif()
 
 if(CMAKE_COMPILER_IS_GNUCXX)
 
@@ -47,12 +39,12 @@
 include_directories(../src/protocols)
 include_directories(common_src)
 
-add_executable(mcu_calibration ${HOST_SOURCES})
+add_executable(MCU_TestBench ${HOST_SOURCES})
 if(WIN32)
-target_link_libraries(mcu_calibration LimeSuite sqlite3_static)
+target_link_libraries(MCU_TestBench LimeSuite sqlite3_static)
 else()
-target_link_libraries(mcu_calibration LimeSuite sqlite3)
+target_link_libraries(MCU_TestBench LimeSuite sqlite3)
 endif()
 if(WIN32)
-    target_link_libraries(mcu_calibration ${CYAPI_LIBRARIES} SetupAPI)
+    target_link_libraries(MCU_TestBench ${CYAPI_LIBRARIES} SetupAPI)
 endif()

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,6 @@
     ErrorReporting.h
     LimeSuiteConfig.h
     ADF4002/ADF4002.h
-    version.h
     lms7002m_mcu/MCU_BD.h
     lms7002m_mcu/MCU_File.h
     ConnectionRegistry/IConnection.h
@@ -251,15 +250,6 @@
 endif()
 
 ########################################################################
-## update version.h
-########################################################################
-set(AUTO_UPDATE_VERSION OFF CACHE BOOL "Uses python script to increment version")
-if(AUTO_UPDATE_VERSION)
-	add_custom_target(updateVersion ALL COMMAND python ${CMAKE_CURRENT_SOURCE_DIR}/auto_version.py WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
-	add_dependencies(lms7suite updateVersion)
-endif()
-
-########################################################################
 # boardEmulator -- creates serial port and imitates board communications
 ########################################################################
 if(UNIX)

=== src/ConnectionSTREAM/CMakeLists.txt ===
########################################################################
## Support for USB STREAM connection
########################################################################

if(WIN32)
    find_package(CyAPI)
    set(USB_FOUND ${CYAPI_FOUND})
    set(USB_INCLUDE_DIRS ${CYAPI_INCLUDE_DIRS})
    set(USB_LIBRARIES ${CYAPI_LIBRARIES} SetupAPI)
elseif(UNIX)
    find_package(libusb-1.0)
    set(USB_FOUND ${LIBUSB_1_FOUND})
    set(USB_INCLUDE_DIRS ${LIBUSB_1_INCLUDE_DIRS})
    set(USB_LIBRARIES ${LIBUSB_1_LIBRARIES})
endif()

message(STATUS "USB_INCLUDE_DIRS: ${USB_INCLUDE_DIRS}")
message(STATUS "USB_LIBRARIES: ${USB_LIBRARIES}")

set(THIS_SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/ConnectionSTREAM)

set(CONNECTION_STREAM_SOURCES
    ${THIS_SOURCE_DIR}/ConnectionSTREAMEntry.cpp
    ${THIS_SOURCE_DIR}/ConnectionSTREAM.cpp
    ${THIS_SOURCE_DIR}/ConnectionSTREAMing.cpp
)

set(CONNECTION_STREAM_LIBRARIES
    ${USB_LIBRARIES}
)

########################################################################
## Feature registration
########################################################################
include(FeatureSummary)
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_STREAM "Enable STREAM" ON "ENABLE_LIBRARY;USB_FOUND" OFF)
add_feature_info(ConnectionSTREAM ENABLE_STREAM "STREAM Connection support")
if (NOT ENABLE_STREAM)
    return()
endif()

########################################################################
## Add to library
########################################################################
target_include_directories(LimeSuite PUBLIC ${USB_INCLUDE_DIRS})
target_sources(LimeSuite PRIVATE ${CONNECTION_STREAM_SOURCES})
target_link_libraries(LimeSuite ${CONNECTION_STREAM_LIBRARIES})

=== debian/changelog ===
limesuite (16.12.0+dfsg-1) unstable; urgency=medium

  * New upstream release 16.12.0
  * Add patch fix-abs-overload taken from upstream git fixing compile
    error for the new version
  * Rename liblimesuite16.8-1 to liblimesuite16.12-1 to follow soname
    change
  * Add watch file

 -- Andreas Bombe <aeb@debian.org>  Thu, 12 Jan 2017 01:40:43 +0100

limesuite (16.8.23.819+git20161221+dfsg-2) unstable; urgency=medium

  * Link to libatomic (Closes: #849536)
  * Link with --as-needed 
  * Make liblimesuite-dev Multi-Arch: same and limesuite-udev
    Multi-Arch: foreign
  * Extend patch fix-icon-install to make sure desktop files are
    installed on all architectures, not just Linux
  * Add patch fix-libusb-include to fix sources including
    <libusb-1.0/libusb.h> when <libusb.h> is sufficient and doesn't
    break kfreebsd

 -- Andreas Bombe <aeb@debian.org>  Fri, 06 Jan 2017 04:34:07 +0100

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 Package: limesuite
 Architecture: any
-Depends: liblimesuite16.8-1 (>= ${binary:Version}),
+Depends: liblimesuite16.12-1 (>= ${binary:Version}),
          python, python-soapysdr,
          ${shlibs:Depends}, ${misc:Depends}
 Description: tools to test, control and update LMS7 transceiver based hardware
@@ -31,7 +31,7 @@
  This package contains the command line and GUI tools to control and update the
  hardware devices.
 
-Package: liblimesuite16.8-1
+Package: liblimesuite16.12-1
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -47,7 +47,8 @@
 Package: liblimesuite-dev
 Section: libdevel
 Architecture: any
-Depends: liblimesuite16.8-1 (= ${binary:Version}),
+Multi-Arch: same
+Depends: liblimesuite16.12-1 (= ${binary:Version}),
          ${misc:Depends}
 Description: library to access LMS7 transceiver based hardware (development)
  Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
@@ -59,7 +60,7 @@
 Package: soapysdr0.5-2-module-lms7
 Architecture: any
 Multi-Arch: same
-Depends: liblimesuite16.8-1 (>= ${binary:Version}),
+Depends: liblimesuite16.12-1 (>= ${binary:Version}),
          ${shlibs:Depends}, ${misc:Depends}
 Description: Lime Microsystems LMS7 device support for SoapySDR
  Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF
@@ -84,6 +85,7 @@
 Package: limesuite-udev
 Section: libs
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Lime Suite - USB rules for udev
  Lime Suite is a collection of software supporting Lime Microsystems LMS7 RF

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,7 @@
 # -*- makefile -*-
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 # extract the architecture for setting the library path suffix
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
